//---------------------------------------------------------------------------
// #include <vcl.h>
// #include <stdio.h>
// #include <stdlib.h>
#include "stdafx.h"
#include <iostream>

// #pragma hdrstop

#include "C_SNAKE.h"

using namespace std;

//---------------------------------------------------------------------------
// #pragma package(smart_init)

CSnake::CSnake()
{
  con_bool= true;                // For a GUI-Application  FALSE !!!
  FE_bool= false;
  input_buffer[0]= 0;
}

bool CSnake::Read_response()
/*
   Read reply from the Snake-Controler
*/
{ int      count;               // Number of chars read
  char     tst[30];             // Chars read - only 1 Char should be enaugh
  UINT     resu;                // Handle to Timer
  tagMSG   myMSG;               // Windows Message
  bool     read_time_out;

tst[0]= 20;                     //  to get the loop working
count= 0;                       // no char read yet

while (tst[0] != 13)
  { read_time_out= false;                 // no timeout
    resu= SetTimer(NULL, 1, 500, NULL);      // start Timer
//                  (TIMERPROC) TimerProce);
    if (resu == 0)
      { if (con_bool)
            cout << "FAIL -- TIMER" << endl;
        else
            MessageBox(NULL, "FAIL -- TIMER", NULL, MB_OK);
        return false; };

    do
      { //  Application->ProcessMessages();
        if (PeekMessage(&myMSG, NULL, WM_TIMER, WM_TIMER, PM_REMOVE))   // Look for Timermessage
            { if (myMSG.wParam == resu)              // from  our timer?
                 read_time_out= true;                // if yes -> flag timeout
              else if (myMSG.lParam != NULL)         // else insert it into the queue again
                 PostMessage(myMSG.hwnd, WM_TIMER, myMSG.wParam, myMSG.lParam);
            };
        if (ReadFile(hkomm, tst, 1, &lpnumber, NULL))  // try to read one char
          { if (lpnumber > 0)
              { input_buffer[count]= tst[0];        // char to buffer
                count++; };
           }
        else
          { FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,      //  serious Error !!!
                          GetLastError(),
                          LANG_NEUTRAL + (SUBLANG_DEFAULT << 10),
                          lpmel, 1024, NULL);
             if (con_bool)
                 printf("%s\n", lpmel);
             else
                 MessageBox(NULL, lpmel, NULL, MB_OK);
             return false; };
     } while ((lpnumber == 0) && !read_time_out);

   KillTimer(NULL, resu);
   if (read_time_out)
      { if (con_bool)
            printf( "NO CONNECTION!\n");
        else
            MessageBox(NULL, "NO C0NNECTION", NULL, MB_OK);
        return false;
//        lasterror= T_ERR_TIMEOUT;
      };
  };

if (count > 1) input_buffer[count-1]= 0;         //  Form a valid string
else           input_buffer[0]= 0;
return true;
}

bool CSnake::Mywrite(unsigned n)
/*
    Output n chars to the Snake-Controler
*/
{
if (!WriteFile(hkomm,  &obuff , n , &lpnumber, NULL))
   { FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,
                   GetLastError(),
                   (LANG_NEUTRAL + (SUBLANG_DEFAULT << 10)),
                   lpmel, 1024, NULL);
     if (con_bool) printf("%s\n", lpmel);
     else          MessageBox(NULL, lpmel, NULL, MB_OK);
     return false; };
if(lpnumber < n)
   { if (con_bool)
         printf("ERROR writing to socket\n");
     else
         MessageBox(NULL, "ERROR writing to socket", NULL, MB_OK);
     return false; };
return true;
}


bool CSnake::Connect()
/*
    Initialize connection to the Snake-Controler
*/
{  DCB              lpDCB;
   COMMTIMEOUTS   lptimeout;

hkomm= CreateFile("COM1", GENERIC_READ | GENERIC_WRITE,
                  0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,
                  0);
if (hkomm ==  INVALID_HANDLE_VALUE)
   { FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,
                   GetLastError(),
                   (LANG_NEUTRAL + (SUBLANG_DEFAULT << 10)),
                   lpmel, 1024, NULL);
     if (con_bool) printf("%s\n", lpmel);
     else          MessageBox(NULL, lpmel, NULL, MB_OK);
     return false; };

GetCommTimeouts(hkomm, &lptimeout);
lptimeout.ReadIntervalTimeout= MAXDWORD;
SetCommTimeouts(hkomm, &lptimeout);

GetCommState(hkomm, &lpDCB);
lpDCB.DCBlength= sizeof(lpDCB);
lpDCB.BaudRate= CBR_9600;
lpDCB.ByteSize= 8;
lpDCB.Parity= NOPARITY;
lpDCB.StopBits= ONESTOPBIT;

if (!SetCommState(hkomm, &lpDCB))
   { FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,
                 GetLastError(),
                 (LANG_NEUTRAL << 10) + (SUBLANG_DEFAULT << 10),
                 lpmel, 1024, NULL);
     if (con_bool) cout << lpmel << endl;
     else          MessageBox(NULL, lpmel, NULL, MB_OK);
     return false;
   };
return true;
}

void CSnake::Disconnect()
{
   FE_bool= false;
   CloseHandle(hkomm);
}

void CSnake::get_response(char *buff)
/*  Return last answer to the user
    Note:  buff has to be large enaugh!!
*/
{
  strcpy(buff, input_buffer);
}

void CSnake::get_obuff(char *buff)
/*  Return the last command written ( for Debug only)
    Note:  buff has to be large enaugh
*/
{ int i;

  i= 0;

  while (obuff[i] != 13)
    { buff[i]= obuff[i];
      i= i + 1; }
  buff[i]= 0;
}


void CSnake::write_FF()
{
   strcpy(obuff, "FF");
   obuff[2]= 13;
   Mywrite(3);
   FE_bool= false;
}

void CSnake::write_FE()
{
   strcpy(obuff, "FE");
   obuff[2]= 13;
   Mywrite(3);
   FE_bool= true;
   Read_response();
}

void CSnake::write_SO()
{
   strcpy(obuff, "SO");
   obuff[2]= 13;
   Mywrite(3);
   if (FE_bool) Read_response();
}

void CSnake::write_SF()
{
   strcpy(obuff, "SF");
   obuff[2]= 13;
   Mywrite(3);
   if (FE_bool) Read_response();
}

void CSnake::write_SE(int chan)
{  if ((chan < 0) || (chan > 9))
      { chan= 9;
        if (con_bool)
            cout << " write_SE -- ungltige Nummer" << endl;
        else
            MessageBox(NULL, " write_SE -- ungltige Nummer",
            NULL, MB_OK); 
	};

   strcpy(obuff, "SE0");
// #pragma warn -8071
   obuff[3]= '0' + chan;
// #pragma warn +8071
   obuff[4]= 13;
   Mywrite(5);
   if (FE_bool) Read_response();
}

void CSnake::write_SD(int chan)
{  if ((chan < 0) || (chan > 9))
      { chan= 9;
        if (con_bool)
            cout << " write_SD -- ungltige Nummer" << endl;
        else
            MessageBox(NULL, " write_SD -- ungltige Nummer",
                       NULL, MB_OK);
		};

   strcpy(obuff, "SD0");
// #pragma warn -8071
   obuff[3]= '0' + chan;
// #pragma warn +8071
   obuff[4]= 13;
   Mywrite(5);
   if (FE_bool) Read_response();
}

void CSnake::write_SC()
{
   strcpy(obuff, "SC");
   obuff[2]= 13;
   Mywrite(3);
   if (FE_bool) Read_response();
}

void CSnake::write_SG(int wert)
{ char   hb[20];

  if (wert < 500) wert= 500;
  if (wert > 2500) wert= 2500;

  sprintf(hb, "%04x", wert);
  strcpy(obuff, "SG");
  obuff[2]= hb[0];
  obuff[3]= hb[1];
  obuff[4]= hb[2];
  obuff[5]= hb[3];
  obuff[6]= 13;
  Mywrite(7);
  if (FE_bool) Read_response();
};

void CSnake::write_SW(int chan, int wert)
{ char  hb[20];

  if ((chan < 0) || (chan > 9))
      { chan= 9;
        if (con_bool)
           cout << " write_SW -- ungltige Nummer" << endl;
        else
           MessageBox(NULL, " write_SW -- ungltige Nummer",
                      NULL, MB_OK);
  };

  if (wert < 500) wert= 500;
  if (wert > 2500) wert= 2500;

  sprintf(hb, "%04x", wert);

  strcpy(obuff, "SW0");
// #pragma warn -8071
  obuff[3]= '0' + chan;
// #pragma warn +8071
  obuff[4]= hb[0];
  obuff[5]= hb[1];
  obuff[6]= hb[2];
  obuff[7]= hb[3];
  obuff[8]= 13;
  Mywrite(9);

  if (FE_bool) Read_response();
}

void CSnake::write_YT(int wert1, int wert2)
{ char hb[20];

  if (wert1 < 0) wert1= 0;
  if (wert1 > 255) wert1= 255;
  if (wert2 < 0) wert2= 0;
  if (wert2 > 255)wert2= 255;

  sprintf(hb, "%04x", wert1);
  strcpy(obuff, "YT");
  obuff[2]= hb[2];
  obuff[3]= hb[3];
  sprintf(hb, "%04x", wert2);
  obuff[4]= hb[2];
  obuff[5]= hb[3];
  obuff[6]= 13;
  Mywrite(7);
  if (FE_bool) Read_response();
}

void CSnake::write_YF()
{
  strcpy(obuff, "YF");
  obuff[2]= 13;
  Mywrite(3);
  if (FE_bool) Read_response();
}

